"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

require("./component.scss");

var _icons = require("./icons");

var _fastDeepEqual = _interopRequireDefault(require("fast-deep-equal"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); Object.defineProperty(subClass, "prototype", { writable: false }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

var Dropdown = /*#__PURE__*/function (_React$Component) {
  _inherits(Dropdown, _React$Component);

  var _super = _createSuper(Dropdown);

  function Dropdown(props, context) {
    var _this;

    _classCallCheck(this, Dropdown);

    _this = _super.call(this, props, context);
    _this.state = {
      componentID: (Math.random() + 1).toString(36).substring(7),
      isOpen: false,
      filterValue: '',
      selectedValues: props.value ? props.value.toString().split(',') : [],
      selectedValue: props.value
    };
    _this.myRef = /*#__PURE__*/_react["default"].createRef();
    document.addEventListener("click", _this.hidePanel.bind(_assertThisInitialized(_this)), true);
    return _this;
  }

  _createClass(Dropdown, [{
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      document.removeEventListener("click", this.hidePanel.bind(this), true);
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props = this.props,
          value = _this$props.value,
          multiple = _this$props.multiple;

      if (!(0, _fastDeepEqual["default"])(value, prevProps.value)) {
        if (multiple) {
          this.setState({
            selectedValues: value.toString().split(',')
          });
        } else {
          this.setState({
            selectedValue: value
          });
        }
      }
    }
  }, {
    key: "clean",
    value: function clean(value) {
      this.setState({
        selectedValues: [],
        selectedValue: arguments.length ? value : this.props.multiple ? [] : ''
      }, this.fireOnChange);
    }
  }, {
    key: "hidePanel",
    value: function hidePanel(e) {
      if (!this.myRef.current) return;

      var root = _reactDom["default"].findDOMNode(this.myRef.current);

      if (root && root.contains(e.target)) return;
      this.setState({
        isOpen: false
      });
    }
  }, {
    key: "toggle",
    value: function toggle() {
      this.setState({
        isOpen: !this.state.isOpen
      });
    }
  }, {
    key: "select",
    value: function select(item) {
      var multiple = this.props.multiple;
      if (multiple) return false;
      this.setState({
        selectedValue: item.value,
        isOpen: false
      }, this.fireOnChange);
    }
  }, {
    key: "selectMultiple",
    value: function selectMultiple(e, item) {
      var checked = e.currentTarget.checked;
      this.setState(function (prev) {
        var selectedValues = prev.selectedValues;

        if (checked) {
          selectedValues.push(item.value);
        } else {
          selectedValues = selectedValues.filter(function (val) {
            return val != item.value;
          });
        }

        return {
          selectedValues: selectedValues
        };
      }, this.fireOnChange);
    }
  }, {
    key: "fireOnChange",
    value: function fireOnChange() {
      var onChange = this.props.onChange;
      if (onChange) onChange(this.getSelected());
    }
  }, {
    key: "getSelected",
    value: function getSelected() {
      var _this$props2 = this.props,
          data = _this$props2.data,
          multiple = _this$props2.multiple;
      var _this$state = this.state,
          selectedValue = _this$state.selectedValue,
          selectedValues = _this$state.selectedValues;
      if (multiple) return data.filter(function (p) {
        return selectedValues.includes(p.value);
      });
      return data.find(function (p) {
        return p.value === selectedValue;
      }) || {
        text: '',
        value: ''
      };
    }
  }, {
    key: "getUpOrDownIcon",
    value: function getUpOrDownIcon(isOpen) {
      if (isOpen) {
        return this.props.sign == 'caret' ? /*#__PURE__*/_react["default"].createElement(_icons.CaretUp, null) : /*#__PURE__*/_react["default"].createElement(_icons.ChevronUp, null);
      } else {
        return this.props.sign == 'caret' ? /*#__PURE__*/_react["default"].createElement(_icons.CaretDown, null) : /*#__PURE__*/_react["default"].createElement(_icons.ChevronDown, null);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          data = _this$props3.data,
          multiple = _this$props3.multiple,
          optionRender = _this$props3.optionRender,
          searchable = _this$props3.searchable,
          placeHolderStr = _this$props3.placeHolderStr,
          valueRender = _this$props3.valueRender,
          searchIcon = _this$props3.searchIcon;
      var _this$state2 = this.state,
          isOpen = _this$state2.isOpen,
          filterValue = _this$state2.filterValue,
          selectedValues = _this$state2.selectedValues;
      var selected = this.getSelected();

      var getItemText = function getItemText(item) {
        return optionRender ? optionRender(item.text, item) : item.text || item.value;
      };

      var getDefaultVal = function getDefaultVal(item) {
        if (multiple) {
          var snips = selected.map(function (p, i) {
            return /*#__PURE__*/_react["default"].createElement("span", {
              key: "span-".concat(i)
            }, getItemText(p));
          });
          return snips.length > 0 ? snips : placeHolderStr;
        }

        return getItemText(item) || placeHolderStr;
      };

      var getIfChecked = function getIfChecked(item) {
        if (multiple) return selected.find(function (p) {
          return p.value == item.value;
        }) !== undefined;
        return selected.value == item.value;
      };

      var list = filterValue ? data.filter(function (_ref) {
        var text = _ref.text,
            value = _ref.value;
        return (text || value).toLowerCase().includes(filterValue.toLowerCase()) || selectedValues.includes(value);
      }) : data;
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: this.myRef,
        className: 'lt-react-dropdown ' + (this.props.className || '')
      }, /*#__PURE__*/_react["default"].createElement("div", {
        className: "select",
        onClick: this.toggle.bind(this)
      }, /*#__PURE__*/_react["default"].createElement("span", {
        className: "text"
      }, !!searchIcon && /*#__PURE__*/_react["default"].createElement("i", {
        className: searchIcon
      }), (valueRender || getDefaultVal)(selected)), this.getUpOrDownIcon(isOpen)), /*#__PURE__*/_react["default"].createElement("div", {
        className: 'panel' + (!this.state.isOpen && ' hide' || '')
      }, searchable && /*#__PURE__*/_react["default"].createElement("input", {
        type: "text",
        ref: function ref(input) {
          return input && input.focus();
        },
        onChange: function onChange(e) {
          return _this2.setState({
            filterValue: e.currentTarget.value
          });
        }
      }), /*#__PURE__*/_react["default"].createElement("ul", null, list.map(function (item, i) {
        var boxID = "box-".concat(_this2.state.componentID, "-").concat(i);
        return /*#__PURE__*/_react["default"].createElement("li", {
          key: "index-".concat(i),
          onClick: _this2.select.bind(_this2, item),
          className: getIfChecked(item) ? 'active' : ''
        }, multiple && /*#__PURE__*/_react["default"].createElement("input", {
          type: "checkbox",
          id: boxID,
          checked: getIfChecked(item),
          onChange: function onChange(e) {
            return _this2.selectMultiple(e, item);
          }
        }), multiple ? /*#__PURE__*/_react["default"].createElement("label", {
          htmlFor: boxID
        }, getItemText(item)) : getItemText(item));
      }))));
    }
  }]);

  return Dropdown;
}(_react["default"].Component);

exports["default"] = Dropdown;